#include <stdio.h>
#include <stdlib.h>
#include <string.h>


void findPath(char** input, int** path, int xStart, int yStart, int n, int m) {
	if (xStart+1 < n && input[xStart+1][yStart] != 'W' && input[xStart+1][yStart] != 'F' && path[xStart][yStart] < path[xStart+1][yStart]) {
		path[xStart+1][yStart] = path[xStart][yStart] + 1;
		findPath(input, path, xStart+1, yStart, n , m);
	}
	if (xStart-1 >= 0 && input[xStart-1][yStart] != 'W' && input[xStart-1][yStart] != 'F' && path[xStart][yStart] < path[xStart-1][yStart]) {
		path[xStart-1][yStart] = path[xStart][yStart] + 1;
		findPath(input, path, xStart-1, yStart, n, m);
	}
	if (yStart+1 < m && input[xStart][yStart+1] != 'W' && input[xStart][yStart+1] != 'F' && path[xStart][yStart] < path[xStart][yStart+1]) {
		path[xStart][yStart+1] = path[xStart][yStart] + 1;
		findPath(input, path, xStart, yStart+1, n, m);
	}
	if (yStart-1 >= 0 && input[xStart][yStart-1] != 'W' && input[xStart][yStart-1] != 'F' && path[xStart][yStart] < path[xStart][yStart-1]) {
		path[xStart][yStart-1] = path[xStart][yStart] + 1;
		findPath(input, path, xStart, yStart-1, n, m);
	}
}

void countPath(char** input, int** path, int** countMatrix, int xStart, int yStart, int n, int m) {
	if (xStart+1 < n && input[xStart+1][yStart] != 'W' && input[xStart+1][yStart] != 'F' && path[xStart][yStart] + 1 == path[xStart+1][yStart]){
		countMatrix[xStart+1][yStart]++;
		countPath(input, path, countMatrix, xStart+1, yStart, n , m);
	}
	if (xStart-1 >= 0 && input[xStart-1][yStart] != 'W' && input[xStart-1][yStart] != 'F' && path[xStart][yStart] +1 == path[xStart-1][yStart]){
		countMatrix[xStart-1][yStart]++;
		countPath(input, path, countMatrix, xStart-1, yStart, n, m);
	}
	if (yStart+1 < m && input[xStart][yStart+1] != 'W' && input[xStart][yStart+1] != 'F' && path[xStart][yStart] +1 == path[xStart][yStart+1]){
		countMatrix[xStart][yStart+1]++;
		countPath(input, path, countMatrix, xStart, yStart+1, n, m);
	}
	if (yStart-1 >= 0 && input[xStart][yStart-1] != 'W' && input[xStart][yStart-1] != 'F' && path[xStart][yStart] +1 == path[xStart][yStart-1]){
		countMatrix[xStart][yStart-1]++;
		countPath(input, path, countMatrix, xStart, yStart-1, n, m);
	}
}

void printArray(int* array, int n) {
	printf("\n");
	for (int j=0; j< n; j++)
		printf("%d ", array[j]);
	printf("\n");
}

void printMatrixChar(char** array, int n, int m) {
	printf("\n");
	for (int i=0; i < n; i++) {
		for (int j=0; j< m; j++)
			printf("%c ", array[i][j]);
		printf("\n");
	}
	printf("\n");
}

void printMatrix(int** array, int n, int m) {
	printf("\n");
	for (int i=0; i < n; i++) {
		for (int j=0; j< m; j++)
			printf("%d\t", array[i][j]);
		printf("\n");
	}
	printf("\n");
}

int main(int argc, char** argv) {
	FILE *fin = fopen("input.txt", "r");
	
	int n,m;
	fscanf(fin, "%d ", &n);
 	fscanf(fin, "%d\n", &m);
	
	char** input = (char**) malloc(n * sizeof(char*));
	for (int i=0; i < n; i++)
		input[i] = (char*) malloc(m * sizeof(char));

	//int** path = (int**) calloc(n , sizeof(int*));
	//for (int i=0; i < n; i++)
	//	path[i] = (int*) calloc(m , sizeof(int));

	int** nPath = (int**) calloc(n , sizeof(int*));
	for (int i=0; i < n; i++)
		nPath[i] = (int*) calloc(m , sizeof(int));

	char temp;
	int xPacMan;
	int yPacMan;
	int F = 0;
	int P = 0;
	for (int i=0; i< n; i++) {
		for (int j=0; j < m; j++) {
			fscanf(fin, "%c ", &temp);
			input[i][j] = temp;
			if (temp == 'M') {
				xPacMan = i;
				yPacMan = j;
			} else if (temp == 'F')
				F++;
			else if (temp == 'P')
				P++;
		}
		fscanf(fin, "\n", &temp);
	}
	fclose(fin);

	//printMatrixChar(input, n, m);

	int* xFarray = (int*) malloc(F * sizeof(int));
	int* yFarray = (int*) malloc(F * sizeof(int));
	int* xParray = (int*) malloc(P * sizeof(int));
	int* yParray = (int*) malloc(P * sizeof(int));
	int countF = 0;
	int countP = 0;
	for (int i=0; i < n && (countF < F || countP < P); i++) {
		for (int j=0; j < m; j++) {
			if (input[i][j] == 'F') {
				xFarray[countF] = i;
				yFarray[countF] = j;
				countF++;			
			} else if (input[i][j] == 'P') {
				xParray[countP] = i;
				yParray[countP] = j;
				countP++;	
			}
		}
	}
	
	int** path = (int**) malloc(n * sizeof(int*));
	for (int i=0; i < n; i++) {
		path[i] = (int*) malloc(m * sizeof(int));
		for (int j=0; j < m; j++)
			path[i][j] = 65535;
	}

	for( int i=0; i < countF; i++) {
		path[xFarray[i]][yFarray[i]] = 0;
		findPath(input, path, xFarray[i], yFarray[i], n, m);
		//printMatrix(path, n, m);
	}

	int* resultF = (int*) malloc(countP * sizeof(int));
	for( int i=0; i < countP; i++)
		resultF[i] = path[xParray[i]][yParray[i]];

	for (int i=0; i < n; i++) {
		for (int j=0; j < m; j++)
			path[i][j] = 65535;
	}

	path[xPacMan][yPacMan] = 0;	
	findPath(input, path, xPacMan, yPacMan, n, m);
	
	//printMatrix(path, n, m);

	int** countMatrix = (int**) calloc(n , sizeof(int*));
	for (int i=0; i < n; i++)
		countMatrix[i] = (int*) calloc(m , sizeof(int));

	countMatrix[xPacMan][yPacMan] = 1;
	countPath(input, path, countMatrix, xPacMan, yPacMan, n, m);

	//printMatrix(countMatrix, n, m);

	int result = 0;
	for( int i=0; i < countP; i++) {
		if (path[xParray[i]][yParray[i]] < resultF[i])
			result += countMatrix[xParray[i]][yParray[i]];
	}
	
	//printf("\n   %d\n", result);
	FILE *fout = fopen("output.txt", "w");
	fprintf(fout, "%d", result);
	fclose(fout);
}
